/* A Bison parser, made from config.y
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

# define	NUMBER	257
# define	STRING	258
# define	IPADDRESS	259
# define	STAT	260
# define	HOST	261
# define	NET	262
# define	NETMASK	263
# define	STREAM	264
# define	IS	265
# define	FROM	266
# define	TO	267
# define	ALL	268
# define	EXCEPT	269
# define	ITSELF	270
# define	IN	271
# define	OUT	272
# define	AS	273
# define	DEFINE	274
# define	SLICE	275
# define	OPTION	276
# define	CHANNEL	277
# define	K_FILE	278
# define	K_SYSLOG	279
# define	UDP	280
# define	FACILITY	281
# define	PRIORITY	282
# define	DUMPFILE	283
# define	ABSOLUTE	284
# define	BOGUS	285
# define	EOL	286
# define	USER	287

#line 1 "config.y"

/* This file is part of IPACCT
   Copyright (C) 1999,2000,2001,2002,2003,2004,2005 Sergey Poznyakoff 

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */

#if defined(HAVE_CONFIG_H)
# include <config.h>
#endif

#include <stdlib.h>
#include <stdio.h>
#include <errno.h>
#include <sys/stat.h>
#include <stdarg.h>
#include <netdb.h>
#include <syslog.h>
#include <string.h>
#include <ipacct.h>
	
#define YYDEBUG 1 
#define PARSER_BUFSIZE 128
	/* Note: currently these should be the same: */
#define MAX_STR_LEN PARSER_BUFSIZE
	
#define OPT_EXACT 1
	
struct keyword {
	char *name;
	int val;
};

struct keyword options[] = {
	"exact", OPT_EXACT,
	NULL,    0
};
 
int get_mask_by_length(int len, IPADDR *);
int read_address(char **, IPADDR *);
 
static int xlat_keyword(struct keyword *kw, char *str);
static void yyerrsync();
static void register_address(char *name, IPADDR addr, UINT4 netmask);
void parse_err(char *fmt, ...);

#line 59 "config.y"
#ifndef YYSTYPE
typedef union {
	long number;
	char string[MAX_STR_LEN];
	UINT4 ipaddr;
	network_t network;
	list_t list;
	stream_t stream;
	flow_t flow;
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
#ifndef YYDEBUG
# define YYDEBUG 1
#endif



#define	YYFINAL		98
#define	YYFLAG		-32768
#define	YYNTBASE	37

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 287 ? yytranslate[x] : 68)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,    35,    36,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    34,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     2,     4,     7,     9,    11,    13,    15,    17,
      19,    21,    24,    27,    30,    33,    36,    38,    42,    48,
      52,    58,    63,    65,    67,    69,    71,    72,    74,    76,
      78,    80,    82,    85,    88,    91,    95,    99,   104,   109,
     111,   112,   114,   116,   119,   120,   122,   126,   128,   132,
     133,   135,   138,   140,   143,   147,   151,   153,   155,   157,
     160,   162,   164,   166
};
static const short yyrhs[] =
{
      38,     0,    39,     0,    38,    39,     0,    41,     0,    50,
       0,    51,     0,    53,     0,    67,     0,    40,     0,     1,
       0,    33,     4,     0,     6,    42,     0,    21,    43,     0,
      22,     4,     0,    23,    44,     0,     3,     0,     3,    34,
       3,     0,     3,    34,     3,    34,     3,     0,    24,     4,
      47,     0,    25,    45,    35,    46,    47,     0,    26,    48,
      49,    47,     0,     3,     0,    27,     0,     3,     0,    28,
       0,     0,    30,     0,     5,     0,     4,     0,     3,     0,
       4,     0,    29,     4,     0,     7,     5,     0,     8,    52,
       0,     5,    36,     3,     0,     5,     9,     5,     0,    10,
      54,    55,    66,     0,    10,    54,    55,    56,     0,     4,
       0,     0,    11,     0,    58,     0,    56,    58,     0,     0,
      19,     0,    59,    57,    64,     0,    63,     0,    63,    15,
      63,     0,     0,    60,     0,    13,    65,     0,    60,     0,
      12,    65,     0,    12,    65,    61,     0,    13,    65,    62,
       0,    17,     0,    18,     0,    66,     0,    65,    66,     0,
       5,     0,    52,     0,    14,     0,    20,    54,    65,     0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,   100,   103,   104,   107,   108,   109,   110,   111,   112,
     113,   121,   127,   130,   134,   144,   147,   148,   152,   158,
     163,   168,   175,   176,   179,   180,   183,   187,   193,   194,
     205,   209,   223,   230,   236,   244,   249,   256,   261,   267,
     270,   271,   274,   279,   286,   287,   290,   297,   303,   310,
     318,   319,   325,   326,   332,   337,   344,   348,   354,   359,
     366,   371,   372,   379
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "NUMBER", "STRING", "IPADDRESS", "STAT", 
  "HOST", "NET", "NETMASK", "STREAM", "IS", "FROM", "TO", "ALL", "EXCEPT", 
  "ITSELF", "IN", "OUT", "AS", "DEFINE", "SLICE", "OPTION", "CHANNEL", 
  "K_FILE", "K_SYSLOG", "UDP", "FACILITY", "PRIORITY", "DUMPFILE", 
  "ABSOLUTE", "BOGUS", "EOL", "USER", "':'", "'.'", "'/'", "input", 
  "list", "stmt", "user_stmt", "stat_stmt", "stat_cmd", "timeval", 
  "channel", "facility", "priority", "channel_opts", "host", "port", 
  "dump_stmt", "host_stmt", "network", "stream_stmt", "strnam", "is", 
  "stream_decl_list", "as", "stream_decl", "stream_def", "all_addr_list", 
  "to_addr_list", "from_addr_list", "flow_decl", "flow_dir", "addr_list", 
  "address", "defn_stmt", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    37,    38,    38,    39,    39,    39,    39,    39,    39,
      39,    40,    41,    42,    42,    42,    43,    43,    43,    44,
      44,    44,    45,    45,    46,    46,    47,    47,    48,    48,
      49,    49,    50,    51,    51,    52,    52,    53,    53,    54,
      55,    55,    56,    56,    57,    57,    58,    59,    59,    60,
      61,    61,    62,    62,    63,    63,    64,    64,    65,    65,
      66,    66,    66,    67
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     1,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     2,     2,     2,     1,     3,     5,     3,
       5,     4,     1,     1,     1,     1,     0,     1,     1,     1,
       1,     1,     2,     2,     2,     3,     3,     4,     4,     1,
       0,     1,     1,     2,     0,     1,     3,     1,     3,     0,
       1,     2,     1,     2,     3,     3,     1,     1,     1,     2,
       1,     1,     1,     3
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
       0,    10,     0,     0,     0,     0,     0,     0,     0,     0,
       2,     9,     4,     5,     6,     7,     8,     0,     0,     0,
      12,    33,     0,    34,    39,    40,     0,    32,    11,     3,
      16,    13,    14,     0,     0,     0,    15,     0,     0,    41,
       0,    60,    62,    61,    63,    58,     0,    26,    22,    23,
       0,    29,    28,     0,    36,    35,     0,     0,    38,    42,
      44,    47,    37,    59,    17,    27,    19,     0,    30,    31,
      26,    49,    49,    43,    45,     0,     0,     0,    24,    25,
      26,    21,     0,    50,    54,     0,    52,    55,    56,    57,
      46,    48,    18,    20,    51,    53,     0,     0,     0
};

static const short yydefgoto[] =
{
      96,     9,    10,    11,    12,    20,    31,    36,    50,    80,
      66,    53,    70,    13,    14,    43,    15,    25,    40,    58,
      75,    59,    60,    83,    84,    87,    61,    90,    44,    45,
      16
};

static const short yypact[] =
{
       9,-32768,    36,     7,    15,    42,    42,    46,    52,     1,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,     2,    56,    37,
  -32768,-32768,    -3,-32768,-32768,    28,    31,-32768,-32768,-32768,
      38,-32768,-32768,    66,    10,    48,-32768,    68,    71,-32768,
      13,    -3,-32768,-32768,    31,-32768,    72,    11,-32768,-32768,
      41,-32768,-32768,    61,-32768,-32768,    31,    31,    54,-32768,
      58,    63,-32768,-32768,    45,-32768,-32768,     0,-32768,-32768,
      11,    30,    35,-32768,-32768,    51,    54,    77,-32768,-32768,
      11,-32768,    31,-32768,-32768,    31,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,    31,    31,    81,    82,-32768
};

static const short yypgoto[] =
{
  -32768,-32768,    62,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
     -56,-32768,-32768,-32768,-32768,    79,-32768,    78,-32768,-32768,
  -32768,    27,-32768,    14,-32768,-32768,    12,-32768,   -34,   -40,
  -32768
};


#define	YYLAST		88


static const short yytable[] =
{
      62,    -1,     1,    78,    63,    30,    37,     2,     3,     4,
       1,     5,    21,    48,    81,     2,     3,     4,    41,     5,
      22,     6,    71,    72,    93,    56,    57,    42,    79,     6,
       7,    63,    63,    38,     8,    41,    41,    49,     7,    39,
      41,    65,     8,    82,    42,    42,    24,    85,    94,    42,
      27,    95,    51,    52,    63,    63,    28,    17,    18,    19,
      32,    33,    34,    35,    68,    69,    56,    57,    88,    89,
      47,    29,    46,    54,    55,    64,    67,    74,    76,    77,
      92,    97,    98,    23,    26,    73,    86,     0,    91
};

static const short yycheck[] =
{
      40,     0,     1,     3,    44,     3,     9,     6,     7,     8,
       1,    10,     5,     3,    70,     6,     7,     8,     5,    10,
       5,    20,    56,    57,    80,    12,    13,    14,    28,    20,
      29,    71,    72,    36,    33,     5,     5,    27,    29,    11,
       5,    30,    33,    13,    14,    14,     4,    12,    82,    14,
       4,    85,     4,     5,    94,    95,     4,    21,    22,    23,
       4,    24,    25,    26,     3,     4,    12,    13,    17,    18,
       4,     9,    34,     5,     3,     3,    35,    19,    15,    34,
       3,     0,     0,     4,     6,    58,    72,    -1,    76
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison/bison.simple"

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif

#line 315 "/usr/share/bison/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 10:
#line 114 "config.y"
{
		      yyerrsync();
		      yyerrok;
		      yyclearin;
	      }
    break;
case 11:
#line 122 "config.y"
{
		      user = strdup (yyvsp[0].string);
	      }
    break;
case 13:
#line 131 "config.y"
{
		      slice_interval = yyvsp[0].number;
	      }
    break;
case 14:
#line 135 "config.y"
{
		      switch (xlat_keyword(options, yyvsp[0].string)) {
		      case OPT_EXACT:
			      fixed_clocks++;
			      break;
		      default:
			      parse_err("%s:%d: unknown option");
		      }
	      }
    break;
case 17:
#line 149 "config.y"
{
		      yyval.number = yyvsp[-2].number*60+yyvsp[0].number;
	      }
    break;
case 18:
#line 153 "config.y"
{
		      yyval.number = (yyvsp[-4].number*60+yyvsp[-2].number)*60+yyvsp[0].number;
	      }
    break;
case 19:
#line 159 "config.y"
{
		      if (add_file_channel(yyvsp[-1].string, yyvsp[0].number))
			      error("too many channels");
	      }
    break;
case 20:
#line 164 "config.y"
{
		      if (add_syslog_channel(yyvsp[0].number, yyvsp[-3].number, yyvsp[-1].number))
			      error("too many channels");
	      }
    break;
case 21:
#line 169 "config.y"
{
		      if (add_udp_channel(yyvsp[-2].ipaddr, yyvsp[-1].number, yyvsp[0].number))
			      error("too many channels");
	      }
    break;
case 26:
#line 184 "config.y"
{
		      yyval.number = 0;
	      }
    break;
case 27:
#line 188 "config.y"
{
		      yyval.number = 1;
	      }
    break;
case 29:
#line 195 "config.y"
{
		      struct hostent *hp;
		      if ((hp = gethostbyname(yyvsp[0].string)) == NULL) { 
			      parse_err("host not found: %s", yyvsp[0].string);
			      YYERROR;
		      }
		      yyval.ipaddr = *(IPADDR*)hp->h_addr;
	      }
    break;
case 30:
#line 206 "config.y"
{
		      yyval.number = ntohs(yyvsp[0].number);
	      }
    break;
case 31:
#line 210 "config.y"
{
		      struct servent *s;

		      s = getservbyname(yyvsp[0].string, "udp");
		      if (s)
			      yyval.number = s->s_port;
		      else {
			      parse_err("no such service: %s", yyvsp[0].string);
			      YYERROR;
		      }
	      }
    break;
case 32:
#line 224 "config.y"
{
		      strcpy(dump_name, yyvsp[0].string);
	      }
    break;
case 33:
#line 231 "config.y"
{
		      char addrbuf[ASCII_IP_LENGTH];
		      ipaddr2str(addrbuf, yyvsp[0].ipaddr);
		      register_address(addrbuf, yyvsp[0].ipaddr, ALLONES);
	      }
    break;
case 34:
#line 237 "config.y"
{
		      char addrbuf[ASCII_IP_LENGTH];
		      ipaddr2str(addrbuf, yyvsp[0].network.addr);
		      register_address(addrbuf, yyvsp[0].network.addr, yyvsp[0].network.netmask);
	      }
    break;
case 35:
#line 245 "config.y"
{
		      yyval.network.addr = yyvsp[-2].ipaddr;
		      get_mask_by_length(yyvsp[0].number, &yyval.network.netmask);
	      }
    break;
case 36:
#line 250 "config.y"
{
		      yyval.network.addr = yyvsp[-2].ipaddr;
		      yyval.network.netmask = yyvsp[0].ipaddr;
	      }
    break;
case 37:
#line 257 "config.y"
{
		      /* FIXME: take care of ALL and ITSELF */
		      register_address(yyvsp[-2].string, yyvsp[0].network.addr, yyvsp[0].network.netmask);
	      }
    break;
case 38:
#line 262 "config.y"
{
		      register_stream_list(yyvsp[-2].string, yyvsp[0].list);
	      }
    break;
case 42:
#line 275 "config.y"
{
		      yyval.list = NULL;
		      list_alloc(&yyval.list, &yyvsp[0].stream, sizeof(yyvsp[0].stream));
	      }
    break;
case 43:
#line 280 "config.y"
{
		      list_alloc(&yyvsp[-1].list, &yyvsp[0].stream, sizeof(yyvsp[0].stream));
		      yyval.list = yyvsp[-1].list;
	      }
    break;
case 46:
#line 291 "config.y"
{
		      yyval.stream = yyvsp[-2].stream;
		      yyval.stream.dir = yyvsp[0].number;
	      }
    break;
case 47:
#line 298 "config.y"
{
		      yyval.stream.direct = yyvsp[0].flow;
		      yyval.stream.except.src = NULL;
		      yyval.stream.except.dst = NULL;
	      }
    break;
case 48:
#line 304 "config.y"
{
		      yyval.stream.direct = yyvsp[-2].flow;
		      yyval.stream.except = yyvsp[0].flow;
	      }
    break;
case 49:
#line 311 "config.y"
{
		     network_t all = {0, 0};
		     yyval.list = NULL;
		     list_alloc(&yyval.list, &all, sizeof(all));
	     }
    break;
case 51:
#line 320 "config.y"
{
		     yyval.list = yyvsp[0].list;
	     }
    break;
case 53:
#line 327 "config.y"
{
		     yyval.list = yyvsp[0].list;
	     }
    break;
case 54:
#line 333 "config.y"
{
		     yyval.flow.src = yyvsp[-1].list;
		     yyval.flow.dst = yyvsp[0].list;
	     }
    break;
case 55:
#line 338 "config.y"
{
		     yyval.flow.src = yyvsp[0].list;
		     yyval.flow.dst = yyvsp[-1].list;
	     }
    break;
case 56:
#line 345 "config.y"
{
		     yyval.number = DIR_SRC;
	     }
    break;
case 57:
#line 349 "config.y"
{
		     yyval.number = DIR_DST;
	     }
    break;
case 58:
#line 355 "config.y"
{
		     yyval.list = NULL;
		     list_alloc(&yyval.list, &yyvsp[0].network, sizeof(yyvsp[0].network));
	     }
    break;
case 59:
#line 360 "config.y"
{
		     list_alloc(&yyvsp[-1].list, &yyvsp[0].network, sizeof(yyvsp[0].network));
		     yyval.list = yyvsp[-1].list;
	     }
    break;
case 60:
#line 367 "config.y"
{
		     yyval.network.addr = yyvsp[0].ipaddr;
		     yyval.network.netmask = ALLONES;
	     }
    break;
case 62:
#line 373 "config.y"
{
		     yyval.network.addr = 0;
		     yyval.network.netmask = 0;
	     }
    break;
case 63:
#line 380 "config.y"
{
		     /*   install_netlist($2, $3);*/
	     }
    break;
}

#line 705 "/usr/share/bison/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}
#line 385 "config.y"


FILE *file;
char buffer[PARSER_BUFSIZE];
char *curp = NULL;
static int line;
static char *filename;

void
parse_err(char *fmt, ...)
{
	va_list ap;
	char buf[512];
	
	va_start(ap, fmt);
	sprintf(buf, "%s:%d: ", filename, line);
	vsprintf(buf+strlen(buf), fmt, ap);
	error("%s", buf);
	va_end(ap);
}
		
yyerror(s)
	char *s;
{
	parse_err(s);
}

int
xlat_keyword(kw, str)
	struct keyword *kw;
	char *str;
{
	for (; kw->name; kw++)
		if (strcmp(kw->name, str) == 0)
			break;
	
	return kw->val;
}

int
read_address(line_ptr, addr_ptr)
	char **line_ptr;
	IPADDR *addr_ptr;
{
	char buffer[17];
	char *startp = *line_ptr;
	char *ptr, *endp;
	IPADDR addr;
		
	for (ptr = buffer, endp = startp; *endp; endp++, ptr++)
		if (!(isdigit(*endp) || *endp == '.')) 
			break;
		else if (endp < startp + sizeof(buffer) - 1)
			*ptr = *endp;
		else {
			*line_ptr = ptr;
			return -1;
		}

	*ptr = 0;
	*line_ptr = endp;
	
	if ((addr = get_ipaddr(buffer)) == 0) 
		return -1;
	*addr_ptr = addr;
	return 0;
}

int
get_mask_by_length(len, return_mask)
	int len;
	IPADDR *return_mask;
{
	UINT4 mask;
	
	if (len <= 0 || len > 32) {
		return -1;
	}
		
	mask = 0xfffffffful >> (32-len);
	mask <<= (32-len);
	mask = ntohl(mask);/*FIXME?*/
	*return_mask = mask;
	return 0;
}

struct keyword keywords[] = {
	"host",     HOST,
	"net",      NET,
	"stat",     STAT,
	"slice",    SLICE,       
	"option",   OPTION,      
	/*"debug",    DEBUG,       */
	"dumpfile", DUMPFILE,
	"netmask",  NETMASK,
	"mask",     NETMASK,
	"channel",  CHANNEL,
	"file",     K_FILE,
	"syslog",   K_SYSLOG,
	"udp",      UDP,
	"absolute", ABSOLUTE,
	"stream",   STREAM,
	"is",       IS,
	"from",     FROM,
	"to",       TO,
	"all",      ALL,
	"any",      ALL,
	"except",   EXCEPT,
	"but",      EXCEPT,
	"itself",   ITSELF,
	"define",   DEFINE,
	"as",       AS,
	"input",    IN,
	"output",   OUT,
	"user",     USER,
	NULL, 0
};

struct keyword facility_kw[] = {
	"user",      LOG_USER,
	"daemon",    LOG_DAEMON,
	"auth",      LOG_AUTH,
	"local0",    LOG_LOCAL0,
	"local1",    LOG_LOCAL1,
	"local2",    LOG_LOCAL2,
	"local3",    LOG_LOCAL3,
	"local4",    LOG_LOCAL4,
	"local5",    LOG_LOCAL5,
	"local6",    LOG_LOCAL6,
	"local7",    LOG_LOCAL7,
	NULL, -1
};

struct keyword priority_kw[] = {
	"emerg",     LOG_EMERG,
	"alert",     LOG_ALERT,
	"crit",      LOG_CRIT,
	"err",       LOG_ERR,
	"warning",   LOG_WARNING,
	"notice",    LOG_NOTICE,
	"info",      LOG_INFO,
	"debug",     LOG_DEBUG,
	NULL, -1
};
	
yylex()
{
	int n;
	char *q;
	UINT4 ipaddr;
  again:
	if (!curp || !*curp) 
		curp = fgets(buffer, sizeof(buffer), file);

	if (!curp)
		return 0;

	while (*curp && (*curp == ' ' || *curp == '\t'))
		curp++;

	if (*curp == '#') {
		line++;
		*curp = 0;
		goto again;
	}
	
	if (*curp == '"') {
		++curp;
		q = yylval.string;
		while (*curp != '"') {
			if (*curp == 0 || *curp == '\n') {
				parse_err("missing closing quote");
				*q = 0;
				return BOGUS;
			}
			*q++ = *curp++;
		}
		*q = 0;
		++curp;
		return STRING;
	}

	if (isdigit(*curp)) {
		char *p;
		
		n = strtol(curp, &p, 0);
		if (*p == '.') {
			if (read_address(&curp, &ipaddr)) {
				parse_err("invalid IP address near `%s'",
					  curp);
				return BOGUS;
			}
			yylval.ipaddr = ipaddr;
			return IPADDRESS;
		}
		curp = p;
		yylval.number = n;
		return NUMBER;
	}

	if (isalpha(*curp)) {
		q = yylval.string;
		while (!(isspace(*curp) || ispunct(*curp)))
			*q++ = *curp++;
		*q = 0;

		n = xlat_keyword(keywords, yylval.string);
		if (n == 0) {
			n = xlat_keyword(facility_kw, yylval.string);
			if (n != -1) {
				yylval.number = n;
				return FACILITY;
			}
			n = xlat_keyword(priority_kw, yylval.string);
			if (n != -1) {
				yylval.number = n;
				return PRIORITY;
			}
			return STRING;
		}
		return n;
	}
	
	if (*curp == '\n') { 
		line++;
		curp++;
		goto again;
	}
		
	return *curp++;
}

/* A rudimentary attempt to syncronize input after an error.
 * It is based on the assumption that the keywords start
 * at column 0
 */
void
yyerrsync()
{
	int c;
	while (curp = fgets(buffer, sizeof(buffer), file)) {
		if (!isspace(*curp))
			return;
	}
}

void
read_profile(name)
	char *name;
{
	UINT4 ipaddr;
	UINT4 mask;
	int len;
	struct stat st;
	
	line = 1;
	filename = name;

	if ((file = fopen(filename, "r")) == NULL) {
		error("can't open `%s': %s", filename, strerror(errno));
		exit(1);
	}

	curp = NULL;
	clear_channels();
	yyparse();
	fclose(file);
}

void
debug_profile()
{
	yydebug = 1;
}

void
register_address(name, addr, netmask)
	char *name;
	IPADDR addr;
	UINT4 netmask;
{
	list_t streamlist = NULL;
	stream_t stream;
	network_t network;
	network_t all;
	
	network.addr = addr;
	network.netmask = netmask;
	all.addr = 0;
	all.netmask = 0;
	
	stream.dir = DIR_SRC;
	stream.direct.src = NULL;
	stream.direct.dst = NULL;
	stream.except.src = NULL;
	stream.except.dst = NULL;
	list_alloc(&stream.direct.src, &network, sizeof(network));
	list_alloc(&stream.direct.dst, &all, sizeof(all));
	list_alloc(&streamlist, &stream, sizeof(stream));

	stream.dir = DIR_DST;
	stream.direct.src = NULL;
	stream.direct.dst = NULL;
	list_alloc(&stream.direct.dst, &network, sizeof(network));
	list_alloc(&stream.direct.src, &all, sizeof(all));
	list_alloc(&streamlist, &stream, sizeof(stream));
	register_stream_list(name, streamlist);
}
